package app.wordexam.service;

import app.wordexam.model.ElementInfo;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.jsoup.select.Elements;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.atomic.AtomicBoolean;
import java.util.concurrent.atomic.AtomicInteger;

@Service
public class ElementService {
    public List<ElementInfo> getElementInfo(Elements elements) throws JsonProcessingException {
        List<ElementInfo> elementInfos = new ArrayList<>();
        //從有()開始加入題目
        AtomicBoolean flag = new AtomicBoolean(false);

        AtomicInteger i = new AtomicInteger(0);
        AtomicInteger index = new AtomicInteger(0);

        elements.forEach(element -> {

            //符合(\\d+) 的情況  視為題目,開始蒐集
            String regex = ".*[\\(（].*\\d.*[\\)）].*";
//            String regex = ".*[(].*\\d.*[)].*";
            Boolean isMatch = element.text().matches(regex);

            if (isMatch == true) {
                System.out.println("el:" + element.text());
//                System.out.println(isMatch + "-" + index.get() + ":" + element.text());
                flag.set(true);
                if (flag.get() == true) {
                    ElementInfo elementInfo = new ElementInfo(index.get(), element);
                    elementInfos.add(elementInfo);
                    index.incrementAndGet();
                }
            } else {
                if (flag.get() == true) {
                    ElementInfo elementInfo = new ElementInfo(index.get() - 1, element);
                    elementInfos.add(elementInfo);

                }
            }

            //處理最後一個問題, 選項或圖形部份
            if (i.get() == (elements.size() - 1) && isMatch != true) {
                ElementInfo elementInfo = new ElementInfo(index.get() - 1, element);
                elementInfos.add(elementInfo);
            }

            i.incrementAndGet();

        });

        return elementInfos;
    }
}
